<?php

namespace Uncanny_Automator_Pro;

/**
 * Class Memberpress_Pro_Tokens
 * @package Uncanny_Automator_Pro
 */
class Memberpress_Pro_Tokens {

	/**
	 * Memberpress_Pro_Tokens constructor.
	 */
	public function __construct() {

		add_filter( 'automator_maybe_parse_token', [ $this, 'parse_memberpress_tokens' ], 20, 6 );
	}

	/**
	 * @param $value
	 * @param $pieces
	 * @param $recipe_id
	 * @param $trigger_data
	 * @param $user_id
	 * @param $replace_args
	 *
	 * @return mixed|string
	 */
	public function parse_memberpress_tokens( $value, $pieces, $recipe_id, $trigger_data, $user_id, $replace_args ) {
		$piece = 'MPPRODUCT';
		if ( $pieces ) {
			if ( in_array( $piece, $pieces, false ) ) {
				$trigger_id     = $pieces[0];
				$trigger_log_id = isset( $replace_args['trigger_log_id'] ) ? absint( $replace_args['trigger_log_id'] ) : 0;
				if ( $trigger_data ) {
					global $wpdb;
					$entry = $wpdb->get_var( "SELECT meta_value
													FROM {$wpdb->prefix}uap_trigger_log_meta
													WHERE meta_key = 'MPPRODUCT'
													AND automator_trigger_log_id = {$trigger_log_id}
													AND automator_trigger_id = {$trigger_id}
													LIMIT 0,1" );
					if ( $entry ) {
						$value = get_the_title( $entry );
					}
				}
			}
		}

		return $value;
	}

}